#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "nrf_drv_pwm.h"
#include "usr_config.h"
#include "nrf_drv_wdt.h"
#include "system.h"
#include "bsp_time.h"
#include "nrf_delay.h"
#include "exception.h"

nrf_drv_wdt_channel_id m_channel_id;

void feed_watchdog(void)
{
    nrf_drv_wdt_channel_feed(m_channel_id); 
}

/**
 * @brief WDT events handler.
 */
//extern const char *Test;
void wdt_event_handler(void)
{
//	SEGGER_RTT_printf(0,"wdt_event_handler:%d,process name:%d\n",TIME_GetTicks(),Test);
	Except_Unkown_Reset_WDT_Set();
}

static void WatchDog_Process(void)
{
	 feed_watchdog();
//	 SEGGER_RTT_printf(0,"WatchDog_Process:%d\n",TIME_GetTicks());
}

static void bsp_wdt_init_process(void)
{
	if(Except_TxError(EXCEPT_WDT_INIT,"bsp_wdt_init_error\r\n") == 0)
	{
		Process_Stop(bsp_wdt_init_process);
	}
}

void watchdog_init(void){
	
	int 				ret = 0;
	ret_code_t 	errCode;
	
	nrf_drv_wdt_config_t config = NRF_DRV_WDT_DEAFULT_CONFIG;
	config.interrupt_priority = WDT_IRQ_PRIORITY;
	config.reload_value = WDT_RELOAD_VALUE;
	errCode = nrf_drv_wdt_init(&config, wdt_event_handler);
	if(errCode != NRF_SUCCESS)ret = -1;
	
	errCode = nrf_drv_wdt_channel_alloc(&m_channel_id);
	if(errCode != NRF_SUCCESS)ret = -1;
	
	nrf_drv_wdt_enable();

	Process_Start(1000,"WatchDog_Process",WatchDog_Process);
	
	if(ret == -1)
	{
		Process_Start(0,"bsp_wdt_init_process",bsp_wdt_init_process);
	}
}

